import 'dart:async';

import 'package:example/state/state.dart';
import 'package:osam/domain/store/store.dart';
import 'package:osam/osam.dart';
import 'package:osam/presentation/presenter.dart';

import 'middleware.dart';

class ExamplePresenter extends Presenter<Store<AppState>> {
  int get initialData => store.state.counter;

  Stream<int> get stream => store.state.propertyStream<int>((state) => state.counter);

  void increment() => store.dispatchEvent(event: IncrementEvent());

  void increment2() =>
      store.dispatchEvent(event: Event.modify(reducer: (state, _) => state..increment()));

  @override
  void dispose() {
    // TODO: implement dispose
  }
}
